
REM SPRITE8.BAS
REM 8 by 8 pixel sprite drawing program Version 2.8f
REM Programmed by John Richard Munro Using Microsoft QBasic
REM (C) COPYRIGHT 1994 All Rights Reserved
REM
REM -NOTE- The sprites are saved in "*.lrs" (8068 byte Low Resolution Sprite)
REM        form, and cannot be read or modified using any other program.
REM        If sprites from SPRITE16.BAS are opened by this program, errors
REM        will occur.  (So don't do it)
REM
REM The keys are:
REM
REM    8 ---------- Up
REM    2 ---------- Down
REM    4 ---------- Left
REM    6 ---------- Right
REM    Space Bar -- Paint selected colour
REM    + ---------- Select next colour
REM    - ---------- Select previous colour

DECLARE SUB save (sprite!(), x, y, sx)
DECLARE SUB load (sprite!(), x, y, sx)
DECLARE SUB take (x!, y!, sx!)
DECLARE SUB place (x!, y!, sx!)
DECLARE SUB keys (i$, x!, y!, sx!, sprite!())
DECLARE SUB lpaintit (x!, y!)
DECLARE SUB paintit (x!, y!, sx!, sprite!())
DECLARE SUB background ()

SCREEN 13
DIM sprite(64)
DIM SHARED john%(242)
x = 10
y = 10
sx = 2

CALL background

DO
   i$ = LCASE$(INKEY$)

   CALL take(x, y, sx)
   CALL keys(i$, x, y, sx, sprite())
   CALL place(x, y, sx)
LOOP

SUB background

CLS
COLOR 11

' outside box
LINE (1, 1)-(319, 199), , B

' 256 colors
FOR c = 0 TO 255
   clr = c + 2
   LINE (clr, 175)-(clr, 199), c
NEXT c

' colors box
LINE (1, 175)-(257, 199), , B

' grid vertical lines
FOR verti = 1 TO 8
   h = h + 20
   LINE (h, 1)-(h, 160)
NEXT verti

' grid horizontal lines
FOR horiz = 1 TO 8
   v = v + 20
   LINE (1, v)-(160, v)
NEXT horiz

' actual sprite box
LINE (242, 20)-(253, 31), , B

' command keys
LOCATE 8, 30
COLOR 12
PRINT "S";
COLOR 11
PRINT "ave"

LOCATE 10, 30
COLOR 12
PRINT "L";
COLOR 11
PRINT "oad"

LOCATE 12, 30
COLOR 12
PRINT "N";
COLOR 11
PRINT "ew"

LOCATE 14, 30
COLOR 12
PRINT "E";
COLOR 11
PRINT "xit"

LOCATE 19, 23
COLOR 11
PRINT "Current:"

LOCATE 20, 23
COLOR 11
PRINT "Selected:"

END SUB

SUB keys (i$, x, y, sx, sprite())
   IF i$ = "s" THEN CALL save(sprite(), x, y, sx)
   IF i$ = "l" THEN CALL load(sprite(), x, y, sx)
   IF i$ = "n" THEN ERASE sprite: CALL background: x = 10: y = 10: sx = 2
   IF i$ = "e" THEN GOTO esc
 
 
   IF i$ = "8" AND y > 10 THEN y = y - 20
   IF i$ = "2" AND y < 140 THEN y = y + 20
   IF i$ = "4" AND x > 10 THEN x = x - 20
   IF i$ = "6" AND x < 140 THEN x = x + 20
   IF i$ = "0" THEN sx = 2

   IF i$ = "+" AND sx < 255 THEN sx = sx + 1
   IF i$ = "-" AND sx > 2 THEN sx = sx - 1

   IF i$ = " " OR i$ = CHR$(13) THEN CALL paintit(x, y, sx, sprite())

   GOTO notesc:

esc:
   CLS
   COLOR 7
   END
notesc:
END SUB

SUB load (sprite(), x, y, sx)
COLOR 11

LOCATE 8, 27
PRINT "          "
LOCATE 12, 27
PRINT "          "
LOCATE 14, 27
PRINT "          "
LOCATE 10, 25
PRINT "Load  File  "
LOCATE 11, 25
INPUT "Name"; lname$
lname$ = lname$ + ".lrs"
IF lname$ = "" THEN GOTO cancel

OPEN lname$ FOR RANDOM ACCESS READ AS #2

FOR t = 1 TO 64
 GET #2, t, sprite(t)
NEXT t

CLOSE #2

cancel:
CALL background
IF sprite(1) <> 0 THEN PUT (243, 22), sprite(1)
CALL lpaintit(x, y)
x = 10
y = 10
sx = 2

END SUB

SUB lpaintit (x, y)

 FOR x = 10 TO 160 STEP 20
    FOR y = 10 TO 160 STEP 20
       rx = x / 23
       ry = y / 23
       sx = POINT(rx + 244, ry + 22)
       LINE (x - 8, y - 8)-(x + 9, y + 9), sx, BF
    NEXT y
 NEXT x

END SUB

SUB paintit (x, y, sx, sprite())
 LINE (x - 8, y - 8)-(x + 9, y + 9), sx - 2, BF

 rx = x / 23
 ry = y / 23
 PSET (rx + 244, ry + 22), sx - 2
 LOCATE 20, 30
END SUB

SUB place (x, y, sx)
   PSET (x, 162), 12
   PSET (x, 163), 12
   PSET (x - 1, 163), 12
   PSET (x + 1, 163), 12
 
   PSET (162, y), 12
   PSET (163, y), 12
   PSET (163, y - 1), 12
   PSET (163, y + 1), 12
 
   PSET (sx, 173), 12
   PSET (sx, 172), 12
   IF sx > 2 THEN PSET (sx - 1, 172), 12
   PSET (sx + 1, 172), 12

   clr = POINT(x, y)
   LOCATE 19, 32
   COLOR clr
   PRINT clr
  
   LOCATE 20, 32
   COLOR sx - 2
   PRINT sx - 2

END SUB

SUB save (sprite(), x, y, sx)
COLOR 11

LOCATE 8, 27
PRINT "          "
LOCATE 12, 27
PRINT "          "
LOCATE 14, 27
PRINT "          "
LOCATE 10, 25
PRINT "Save  File  "
LOCATE 11, 25
INPUT "Name"; sname$
sname$ = sname$ + ".lrs"
IF sname$ = "" THEN CALL background: GOTO cancelled

GET (243, 22)-(252, 30), sprite(1)

CALL background

OPEN sname$ FOR RANDOM ACCESS WRITE AS #1

FOR t = 1 TO 64
PUT #1, t, sprite(t)
NEXT t

CLOSE #1

cancelled:
IF sprite(1) <> 0 THEN PUT (243, 22), sprite(1)
CALL lpaintit(x, y)
x = 10
y = 10
sx = 2

END SUB

SUB take (x, y, sx)
   PRESET (x, 162)
   PRESET (x, 163)
   PRESET (x - 1, 163)
   PRESET (x + 1, 163)

   PRESET (162, y)
   PRESET (163, y)
   PRESET (163, y - 1)
   PRESET (163, y + 1)
 
   PRESET (sx, 173)
   PRESET (sx, 172)
   IF sx > 2 THEN PRESET (sx - 1, 172)
   PRESET (sx + 1, 172)
END SUB

